> For the complete documentation index, see [llms.txt](https://docs.cspr.cloud/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.cspr.cloud/rest-api/validator-performance.md).

# Validator performance

The `ValidatorPerformance` entity provides a proxy metric to judge the validator's performance:

* On Casper 1.x, it is calculated as the percentage of rewards received per one token relative to the maximum ratio received by a validator in the given era. A validator that received the highest ratio will have a 100 score.
* On Casper 2.x, it is calculated as the percentage of cited block signatures produced by a validator compared to the total number of blocks produced in the given era. A validator whose signatures were cited for every block will have a 100 score. In the current Mainnet configuration, block signatures can be cited no later than 3 blocks after the block was produced.

## Properties

The `ValidatorPerformance` entity has the following properties:

| Property     | Type         | Description                                              |
| ------------ | ------------ | -------------------------------------------------------- |
| `public_key` | `string(68)` | Validator public key represented as a hexadecimal string |
| `era_id`     | `uint32`     | Era identifier                                           |
| `score`      | `float64`    | Validator performance score for the era                  |

**Example**

```json
{
  "public_key": "01e8121a2586a6add8a65990080633adfa4e0d32088d36d7fb6f6d3ede1bd7b823",
  "era_id": 12013,
  "score": 100
}
```

## Optional properties

None

## Relations

| Entity                                | Mapping property | Description                       |
| ------------------------------------- | ---------------- | --------------------------------- |
| [`Validator`](/rest-api/validator.md) | `public_key`     | Validators have performance score |

## Endpoints

The `ValidatorPerformance` entity has the following endpoints:

* [Get historical validator performance](/rest-api/validator-performance/get-historical-validator-performance.md)
* [Get historical average validator performance](/rest-api/validator-performance/get-historical-average-validator-performance.md)
* [Get historical average validators performances](/rest-api/validator-performance/get-historical-average-validators-performance.md)

## Relation endpoints

None


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation by asking a question.

Perform an HTTP GET request on the following URL with the `ask` and `goal` query parameters:

```
GET https://docs.cspr.cloud/rest-api/validator-performance.md?ask=<question>&goal=<user_goal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is what the user is ultimately trying to achieve, the reason they need the answer. Sharing it helps GitBook give you a better, more relevant answer. A goal is most helpful when it describes the outcome the user wants rather than restating the question. For example, with `ask=how do I create an API token`, a goal like `automate deployments from our CI pipeline` lets GitBook tailor the answer to that use case.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
